﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ForEachExplicitCast {
	class Program {
		static void Main(string[] args) {

			List<int> ints = new List<int> { 1, 2, 3, 256, 257 };
			foreach (byte b in ints) {
				Console.Write($"{b} ");
			}
			Console.WriteLine(); Console.WriteLine();

			// Error CS0030: Cannot convert type 'int' to 'string'
			// foreach (string s in ints) {
			//     Console.Write($"{s} ");
			// }

			//
			Console.Write("Press ENTER to continue ...");
			Console.ReadLine();
			Console.WriteLine();
			//

			List<A> As = new List<A> { new A { Value = 10 }, new A { Value = 20 } };
			foreach (string s in As) {
				Console.Write($"{s} ");
			}
			Console.WriteLine(); Console.WriteLine();
		}
	}

	class A {
		public int Value { get; set; }

		public static explicit operator string(A a) {
			return $"A[Value={a.Value}]";
		}
	}
}
